#include "ObjParser.h"

const short ObjGrammar_Types::yypact[] = {
    23, -32768, -32768,      1,      1,      1,      3,      4, -32768,     23, 
-32768,     -3, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, 
-32768,      1,      1,      1,     -5,      3, -32768, -32768, -32768,      1, 
     1,      1,     -1,      3, -32768, -32768, -32768,      0,      7, -32768, 
    11, -32768,      3, -32768, -32768,     15,     16, -32768
};

const short ObjGrammar_Types::yypgoto[] = {
-32768, -32768,     12, -32768, -32768, -32768, -32768, -32768, -32768,    -22, 
-32768, -32768, -32768,     -4
};

const char ObjGrammar_Types::yytranslate[] = {
     0,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      2,      2,      2,      2, 
     2,      2,      2,      2,      2,      2,      1,      2,      3,      4, 
     5,      6,      7,      8,      9,     10,     11,     12,     13
};

// Prhs + rhs = old grammar... these are only used for debug mode
const short ObjGrammar_Types::yyprhs[] = {
     0,      0,      2,      5,      7,     10,     12,     14,     16,     18, 
    20,     22,     24,     26,     31,     35,     40,     45,     51,     54, 
    55,     57,     61,     67,     72,     75,     77,     79,     81
};

const short ObjGrammar_Types::yyrhs[] = {
    15,     -1,     15,     16,     -2,     16,     -3,     17,     12,     -4, 
    12,     -5,     18,     -6,     19,     -7,     20,     -8,     21,     -9, 
    24,    -10,     25,    -11,     26,    -12,      7,     27,     27,     27, 
   -13,      8,     27,     27,    -14,      8,     27,     27,     27,    -15, 
     9,     27,     27,     27,    -16,     10,     23,     23,     23,     22, 
   -17,     22,     23,    -18,    -19,      3,    -20,      3,     13,      3, 
   -21,      3,     13,      3,     13,      3,    -22,      3,     13,     13, 
     3,    -23,     11,      3,    -24,      5,    -25,      6,    -26,      3, 
   -27,      4,    -28
};

// rline and tname are debug mode only
const short ObjGrammar_Types::yyrline[] = {
     0,     26,     29,     30,     33,     34,     37,     37,     37,     37, 
    37,     37,     37,     40,     43,     44,     47,     50,     53,     54, 
    57,     58,     59,     60,     63,     66,     69,     72,     73
};

const char * const ObjGrammar_Types::yytname[] = {
   "$", "error", "$illegal.", "INTEGER", "FLOAT", 
"GROUP", "USEMTL", "VERTEX", "TEXCOORD", "NORMAL", 
"FACE", "SMOOTH", "ENDL", "SLASH", "file", 
"lines", "line", "command", "vertex", "texcord", 
"normal", "face", "vrefs", "vref", "smooth", 
"group", "usemtl", "value",     ""
};

const short ObjGrammar_Types::yyr1[] = {
     0,     14,     15,     15,     16,     16,     17,     17,     17,     17, 
    17,     17,     17,     18,     19,     19,     20,     21,     22,     22, 
    23,     23,     23,     23,     24,     25,     26,     27,     27
};

const short ObjGrammar_Types::yyr2[] = {
     0,      1,      2,      1,      2,      1,      1,      1,      1,      1, 
     1,      1,      1,      4,      3,      4,      4,      5,      2,      0, 
     1,      3,      5,      4,      2,      1,      1,      1,      1
};

const short ObjGrammar_Types::yytable[] = {
    22,     23,     37,     33,     19,     20,     24,     26,     32,     28, 
    41,     39,     38,     40,     43,     46,     47,     29,     30,     31, 
    44,     27,      0,      0,      0,     34,     35,     36,      1,      2, 
     3,      4,      5,      6,      7,      8
};

const short ObjGrammar_Types::yycheck[] = {
     4,      5,      3,     25,      3,      4,      3,      3,     13,     12, 
     3,     33,     13,     13,      3,      0,      0,     21,     22,     23, 
    42,      9,     -1,     -1,     -1,     29,     30,     31,      5,      6, 
     7,      8,      9,     10,     11,     12
};

const short ObjGrammar_Types::yydefact[] = {
     0,     25,     26,      0,      0,      0,      0,      0,      5,      1, 
     3,      0,      6,      7,      8,      9,     10,     11,     12,     27, 
    28,      0,      0,      0,     20,      0,     24,      2,      4,      0, 
    14,      0,      0,      0,     13,     15,     16,     21,      0,     19, 
     0,     23,     17,     22,     18,      0,      0,      0
};

const short ObjGrammar_Types::yydefgoto[] = {
    45,      9,     10,     11,     12,     13,     14,     15,     42,     25, 
    16,     17,     18,     21
};
